class StockPriceImitation::Generator
  def initialize(tick_count, first_tick_price=1000)
    @tick_count = tick_count
    @first_tick_price = first_tick_price
    @ticks = []
  end

  def execute
    generate!
    @ticks
  end

  private

  def generate!
    @tick_count.times.each do |i|
      if i == 0
        setup_first_tick
        next
      end

      @ticks << generate_tick(@ticks[i-1])
    end
  end

  def setup_first_tick
    @ticks << @first_tick_price
  end

  def generate_tick(previous_price)
    to_zero_if_negative(previous_price + increase)
  end

  def increase
    @first_tick_price * rand(0..0.1) * [-1,1].sample
  end

  def to_zero_if_negative(number)
    if number < 0
      return 0
    end

    number
  end
end
